#ifndef IMAGELOADER_H
#define IMAGELOADER_H
#include <qthread.h>
class ImageLoader : public QThread
{
	public:
		ImageLoader( ImageWindow * parent ){
			this->parent = parent;
			loaded = false;
			c = 0;
			parentSize = parent->size();
		}
			
		void run(){
			loaded = false;
			//decompress .bz2 files automatically
			if( filename.contains( QRegExp ("bz.$")) ){
				// too lazy for a fork
					system( "bzcat" + filename + " > /tmp/tmp.tiff" );
					if( !image[c].load("/tmp/tmp.tiff") )
						cout << "Image loading failed "<< endl;
			}
			//load the image then
			else if( !image[c].load( filename ) )
				cout << "Image Loading failed" << endl;
			loaded = true;
			pix[c] = image[c].smoothScale( parentSize );
		}
				
		void open( QString f ){
			if( filename == f && loaded ) return;
			c = 1 - c;
			filename = f;
			start(); // -> run
		}

		QPixmap * get( QString f ){
			if( parent->size() != parentSize ) {
				parentSize = parent->size();
				pix[c] = image[c].smoothScale( parentSize );
			}
			//block if your already loading
			if( running() ) wait();
			if( filename == f && loaded ) return &pix[c];
			open( f );
			wait();
			return & pix[c];
		}	

		QImage * getImage() { return & image[c]; }
			
	protected:
		ImageWindow * parent;
		QString filename;
		QImage image[2];
		QPixmap pix[2];
		QSize parentSize; //size to scale image too
		int c;
		bool loaded;
};
#endif
