#ifndef IMAGEWINDOW_H
#define IMAGEWINDOW_H
#include <qwidget.h>
#include <qpainter.h>
#include <qvaluestack.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qlabel.h>

enum { POINTS, RECTANGLES, FIXEDRECTANGLES };
class ImageLoader;
class ImageWindow : public QWidget
{
  Q_OBJECT
 public:
  ImageWindow(QWidget* parent, const char * name); 
  protected slots: 
	//* inherited members */
 	// called when some part of the image needs to be redrawn
    void paintEvent( QPaintEvent * );
  // when a butotn is held down, and the mouse is moved this is aclled
    void mouseMoveEvent(QMouseEvent * e);
	// when the mouse is initially presed this is called
    void mousePressEvent(QMouseEvent * e);  
	// when a mouse button is released
    void mouseReleaseEvent(QMouseEvent * e);
	// opens the first image, and if there is a second image it caches it to be loaded, the bool defnes if the secnod string is valid.
    void openFrom(QString, QString = QString::null, bool = false );
	// called when the window is resized
    void resizeEvent(QResizeEvent * e);
	// sets the valuke of the rectangle, and redraws the screen
    void setRect( QValueStack<QRect> a) { rect = a ; update(); }
	void setPoint( QValueStack<QPoint> a ) { point = a; update(); }
	// changes the view rectange to the selected rectangle
    void zoomin();
	// resets the view rectangle to the whole image
    void zoomout();
	// empty functions, was asked for...
    void classify();
    void detect();
	// set working directory
    void setwd(QString nwd){ wd = nwd; }
	// resets the selected rectangle to the size of the image
    void clearrect();
	void setMaxWindows( int );
	void showReplayWindows();
	void setMode( int a ) { 	mode = a; }
	void setModePoint() {  		mode = POINTS; }
	void setModeRect()	{	 	mode = RECTANGLES; }
    void setModeFixedRect() {   mode = FIXEDRECTANGLES; }
    void setFixedWidth(int a ){    fixedWidth =a ;          }
    void setFixedHeight(int a ){   fixedHeight =a ;          }
	void update();
	 
 signals:
	void pointChanged ( QValueStack<QPoint> );
    void rectChanged( QValueStack<QRect> ); // broadcasts the rectangles location
	void getMaxWindows();
 private:
	int mode;
    int fixedWidth;
    int fixedHeight;

	// the current directory
    QString wd;
	// translates between window space and image space
    void translate( int, int, int&, int& );
    void translateInv( int, int, int&, int& );
	int maxWindows;         //maximum number of replay windows

	bool drawing;			//whether or not the are darwnig the rectangle
    QImage* image; 			//the actual image worked on
    QPoint posLastClicked; 	//where to start the rectangle
    QValueStack<QRect> rect;//the rectangle stored, in image coordinates
	QValueStack<QPoint> point;
    QRect viewrect; 		//the part of the image that is viewed, in image coordinates    
	ImageLoader* imageLoader; //the quaint thread that grabs images for you
	bool showWindows;
	QLabel** replayWindows;
};
#endif
