#include <qtextstream.h>
#include <qdir.h>
#include <fstream.h>
#include <qregexp.h>
#include <iostream.h>
#include <qtextstream.h>
#include <ctype.h>
#include "statmanager.h"
#include "statmanager.moc"

void Stat::removeDups()
{
	QValueStack<QRect> nrect;
	int i, j;
	bool add;
	for( i = 0; i < rect.count(); i ++ ) {
		add = true;
		for( j = 0; j < nrect.count(); j ++ )
			if( nrect[j] == rect[i] ){
				add = false;
			}
		if( add )
			nrect.append(rect[i]);
	}
	rect = nrect;
	
	QValueStack<QPoint> npoint;
	for( i = 0; i < point.count(); i ++ ) {
		add = true;
		for( j = 0; j < npoint.count(); j ++ )
			if( npoint[j] == point[i] ){
				add = false;
			}
		if( add ) npoint.append( point[i]) ;
	}
	point = npoint;
}
	  
StatManager::StatManager(QWidget* parent, const char* name)
  : QWidget(parent,name)
{
	pointdatname = "points.dat";
  rectdatname = "rectangles.dat";
  datnames[0].append("undefinedAge.dat");
  	datnames[0].append("child.dat");
  	datnames[0].append("teen.dat");
  	datnames[0].append("adult.dat");
  	datnames[0].append("old.dat");
  datnames[1].append("undefinedExpression.dat");
  	datnames[1].append("normal.dat");
  	datnames[1].append("happy.dat");
  	datnames[1].append("sad.dat");
  datnames[2].append("undefinedGender.dat");
  	datnames[2].append("female.dat");
  	datnames[2].append("male.dat");
  datnames[3].append("undefinedGlasses.dat");
  	datnames[3].append("noGlasses.dat");
  	datnames[3].append("glasses.dat");
  datnames[4].append("undefinedPOV.dat");
  	datnames[4].append("direct.dat");
  	datnames[4].append("threeQuarter.dat");
  	datnames[4].append("profile.dat");
  datnames[5].append("undefinedRace.dat");
  	datnames[5].append("asian.dat");
  	datnames[5].append("black.dat");
 	datnames[5].append("hispanic.dat");
  	datnames[5].append("indian.dat");
  	datnames[5].append("white.dat");
  datnames[6].append("undefinedBrightness.dat");
  	datnames[6].append("bright.dat");
  	datnames[6].append("mediumBrightness.dat");
  	datnames[6].append("dim.dat");
  datnames[7].append("undefinedComplexity.dat");
  	datnames[7].append("complex.dat");
  	datnames[7].append("mediumComplexity.dat");
  	datnames[7].append("simple.dat");
  datnames[8].append("undefinedType.dat");
  	datnames[8].append("pedestrian.dat");
  	datnames[8].append("car.dat");
  	datnames[8].append("truck.dat");
 
  stats.setAutoDelete(true);
  current = NULL;
  openstats();
  it = files.begin();
}

void StatManager::next()
{
	if(files.empty())
		return;
  Stat* temp;
  QValueList<QString>::iterator original;
  if( *it == 0 )
	  it = files.begin();
  original = it;
  int i;
  while( true ){
    it++;
    if(it == files.end() )
      it = files.begin();
    temp = stats[*it];
    if(it == original){
		QMessageBox::information( this, "Gui",
		"All images have been designated");
		return;
	 }
	 bool valid = true;
	 for(i = 0; i < 9; i ++)
		 if( temp->data[i] != 0 )
			 valid = false;
     if( temp->point.count() > 0 || temp->rect.count() > 0) 
         valid = false;
	 if( valid ){
		 loadit();
		 return;
	 }
  }
}

void StatManager::forward()
{
  it++;
  if(it == files.end())	// if you've reached the end circle around
  {
      QMessageBox::information( this, "Gui", "All images viewed");
      it = files.begin();
  }
  loadit();
}

void StatManager::back()
{ 
  if(it == files.begin() )
    it-- = files.end();
  it--;
  loadit();
}

void StatManager::openFiles(QStringList filesToAdd)
{  
  	QDir d;
 	QString dirname = d.absFilePath( filesToAdd[0] );
	dirname = dirname.left( dirname.findRev( QDir::separator() ) ); // returns the directory the file is in
	// works by splitting the string up until the last '/' or '\' depending on os
	qWarning("new dir %s", dirname.latin1() );
	QDir::setCurrent( dirname );
	emit( directoryChanged( dirname ));
	openstats();
  	QValueList<QString>::iterator myit;
  	QString filename;
  	for(myit = filesToAdd.begin(); 
		myit != filesToAdd.end(); 
		myit ++){
	  		filename = *myit;
			filename = filename.section( QDir::separator(), -1 ); // the last part of the filename /home/images/5 -> 5
	  		qWarning("Adding :%s", filename.latin1() );
    		if(files.contains(filename) == 0)
     			files.append(filename);
    		if(stats[filename] == 0)
    			stats.insert(filename, new Stat(filename) );
  }
  next();
}

void StatManager::openDir(QString dirname)
{
	saveAll();
	clearAll();
	cout << "open dir : " << dirname << endl;
  QDir::setCurrent( dirname );
  emit( directoryChanged( dirname ) );
  QDir d( dirname );
  d.setFilter( QDir::Files | QDir::Readable );
  d.setNameFilter("*.jpg *.xpm *.bmp *.bz2 *.tif *.tiff *.pgm *.ppm" );
  int i;
  QStringList filesToOpen;
 	for( i = 0; i < d.count(); i ++)
		filesToOpen.append( d[i] );
  openFiles( filesToOpen );
}

void StatManager::openImages( QStringList filesToOpen )
{
	saveAll();
	clearAll();
	openFiles( filesToOpen );
}

void StatManager::openImageList( QString datfilename )
{
	saveAll();
	clearAll();
	FILE * fh;
	if( openf( fh, datfilename ) ){
		QTextIStream is(fh);
		QStringList filesToOpen;
		QString filename;
		while( filename = is.readLine() ){
			filesToOpen.append( QStringList::split(" ", filename)[0] );
		}
		QDir d;
 		QString dirname = d.absFilePath( datfilename );
		dirname = dirname.left( dirname.findRev( QDir::separator() ) ); // returns the directory the file is in
		QDir::setCurrent( dirname );
		emit( directoryChanged( dirname ));
		qWarning("changing dir to %s", dirname.latin1() );
		openFiles( filesToOpen) ;
	}
}

void StatManager::loadit()
{ 
  if(!files.isEmpty())
    {
      	savestats();
      	//QString filename = imageDirectory.absPath() + "/" + *it;
		QString filename = *it;
      	cout <<"retrieving : " << filename << endl;      
		it++;
		QString next = *it;
		it--;
		
		emit( filenameChanged( filename ));
      	emit(openFrom(filename, next, true));	// open it
     	if(stats[*it] == 0)	// if its not on the hash
			stats.insert(*it, current = new Stat(*it)); // create a new one             
      	else
			current = stats[*it]; // otherwise select it
		int i;
		for(i = 0; i < 9; i ++)
			emit( dataChanged( i, current->data[i] ) );
		emit( rectChanged( current->rect ) );
		emit( pointChanged( current->point ) );
		filesViewed.remove( filename );
		filesViewed.append(  filename );
    }
};

void StatManager::saveto( QString filename, Stat * ptr)
{ 
  if( ptr == NULL )
    ptr = current;
  if( ptr != NULL )
    {
      FILE * fh;
      //      cout << "saving " << ptr->filename << " to dat : " << fname << endl;
      fh = fopen( filename.latin1(), "a");	  
      QTextOStream(fh) << ptr->filename.latin1() << endl;
      fclose(fh);
    }
}

void StatManager::savestats(Stat * ptr)
{
	int i;
	 FILE* fh;
  if(ptr == NULL)
    ptr = current;
  if(ptr!= NULL)
    {
		ptr->rect.remove( QRect() );  //kill banks
		ptr->point.remove( QPoint() );//kill blanks
		if( ptr->rect.count() > 0 )
		{
			 fh = fopen( rectdatname.latin1(), "a" );
			 QTextOStream out(fh);
			 out << ptr->filename.latin1() << ' ' << ptr->rect.count() << ' ';
			 for( i = 0; i < ptr->rect.count(); i ++)
				 out << ptr->rect[i].left() << ' ' << ptr->rect[i].top() << ' ' << ptr->rect[i].right() << ' ' << ptr->rect[i].bottom() << ' ';
			 out << endl;
			 fclose( fh );
		}
		 for(i = 0; i < 9; i ++)
			 if( ptr->data[i] > 0 )
				 saveto( datnames[i][ptr->data[i]], ptr );
    }
}	  

bool StatManager::openf(FILE *& fh, const char * filename)
{
  fh = fopen(filename, "r");
  if(fh == NULL){
	  //qWarning( "Could not open file : %s", filename );
    return false;
  }
  return true;
}

void StatManager::clearAll()
{
  if(current != NULL){
     clear();
	 current = NULL;
  }
  files.clear();
  stats.clear();
  it = files.begin();
}

void StatManager::clear()
{
	int i;
  	current->rect.clear();
	current->point.clear();
	emit( rectChanged( current->rect ));
	emit( pointChanged( current->point ) );
	for(i = 0; i < 9; i ++){
		current->data[i] = 0;
		emit( dataChanged( i, 0 ) );
	}
}

//totally rebuilds all the dat files
void StatManager::saveAll()
{
  system("rm -f *.dat");
  int i, j; 
  QDictIterator<Stat> it( stats );
  FILE * fh;
  bool keepFile; //erase stupid empty dat files
  for(i = 0; i < 9; i ++) //for each kinda data
  	for(j = 1; j < datnames[i].count(); j ++){ //for each file
		keepFile = false;
		fh = fopen( datnames[i][j].latin1(), "a");
		for( it.toFirst(); 	it.current();   ++it) {//go through all files in the stats, not just the filelist
			if( it.current()->data[i] == j ) { //grab the stats that go in that file
				keepFile = true;
				QTextOStream( fh ) << it.current()->filename << endl; //put them in
			}
		}
		fclose( fh );
		if( !keepFile )
			system("rm -f " + datnames[i][j] );
	}
  keepFile = false;
  
  fh = fopen( pointdatname.latin1(), "w");
  QTextOStream pout( fh );
  for( it.toFirst(); it.current(); ++it)
  		{
			it.current()->removeDups();
			if( it.current()->point.count() > 0 ){
				keepFile = true;
				pout		<< it.current()->filename << ' ' << it.current()->point.count() << ' ';
				for(i = 0; i < it.current()->point.count(); i ++ )
					pout << it.current()->point[i].x() << ' ' << it.current()->point[i].y() << ' ';
				pout << endl;
			}
		}
  fclose( fh );
  if( !keepFile )
	  system("rm -f " + pointdatname );
  
  
  fh = fopen( rectdatname.latin1(), "w" );
  QTextOStream out( fh );
	for( it.toFirst(); it.current(); ++it ){
		  	if( it.current()->rect.count() > 0 ){
				keepFile = true;
				out     << it.current()->filename << ' ' << it.current()->rect.count() << ' ';
				for(i = 0; i < it.current()->rect.count(); i ++)
					out		<< it.current()->rect[i].left() << ' ' 
			 		  		<< it.current()->rect[i].top() << ' ' 
			  		  		<< it.current()->rect[i].right() << ' ' 
			  		  		<< it.current()->rect[i].bottom() << ' ';
				out << endl;
			}
		}
 	fclose(fh);	
	if( !keepFile )
		system("rm -f " + rectdatname);
}

//loads all the dat files in the current directory
void StatManager::openstats()
{
	stats.clear();
	qWarning( "Opening stats in directory %s", QDir::current().path().latin1() );
  int i,j ;
  FILE * fh; 
  QString imagename;
  for( i = 0; i < 9; i ++ )
	  for( j = 0; j < datnames[i].count(); j++ )
		  if( openf( fh, datnames[i][j]) ){
			  QTextIStream is(fh);
			  while( imagename = is.readLine() ){
				  if( stats[ imagename ] == 0 )
					  stats.insert( imagename, new Stat( imagename ) );
				  stats[ imagename ]->data[i] = j;
			  }
			  fclose( fh );
		  }
  int count;
  if( openf( fh, pointdatname ) ){
  	int x, y;
	  QTextIStream is( fh );
	  QString iline;
	  QStringList parts;
	  while( iline = is.readLine() )
	  {
		  parts = QStringList::split(" ", iline );
		  imagename = parts[0];
		  count = parts[1].toInt();
		  if( stats[imagename] == 0 )
			  stats.insert( imagename, new Stat( imagename ) );
		  for( i = 2; i + 1 < parts.count(); i += 2){
			  x = parts[i].toInt();
			  y = parts[i+1].toInt();
			  stats[imagename]->point.push( QPoint( x, y ) );
		  }
	  }
	  fclose( fh );
  }
  
  if(openf( fh, rectdatname ) ){
	  
	  int left, top, right, bottom;
	  QTextIStream is( fh );
	  QString iline;
	  QStringList parts;
	  while( iline = is.readLine() )
	  {
		  parts = QStringList::split(" ", iline );
		  imagename = parts[0];
		  count = parts[1].toInt();
	  	  if( stats[ imagename ]== 0)
		      stats.insert( imagename, new Stat( imagename) );
		  for(i = 2; i+3 < parts.count(); i += 4 ){
			  left =   parts[i].	toInt();
			  top =    parts[i+1].	toInt();
			  right =  parts[i+2].	toInt();
			  bottom = parts[i+3].	toInt();
		   	  stats[ imagename ]->rect.push( QRect( left, top, right-left+1, bottom-top+1 ) );
		  }
	  }
	  fclose( fh );
  }
}

void StatManager::replay()
{
	int i;
	for(i = 0; i < filesViewed.count(); i ++ )
		qWarning("%s", filesViewed[i].latin1() );
	emit(  openReplays() );
	openImages( filesViewed );
}

void StatManager::getMaxWindows()
{
	int i;
	int maxwindows = 0;
	for ( i = 0; i < files.count(); i ++ )
		if( stats[files[i]]->rect.count() + stats[files[i]]->point.count() > maxwindows )
			maxwindows = stats[files[i]]->rect.count() + stats[files[i]]->point.count();
	emit( setMaxWindows( maxwindows ) );
}

void StatManager::popRect()
{
	current->rect.pop();
	emit( rectChanged( current->rect ) );
}

void StatManager::popPoint()
{
	current->point.pop();
	emit( pointChanged( current->point ) );
}
