#ifndef STATMANAGER_H
#define STATMANAGER_H
#include <qvaluelist.h>
#include <qstringlist.h>
#include <qdict.h>
#include <qrect.h>
#include <qwidget.h>
#include <qdialog.h>
#include <qmessagebox.h>
#include <qvaluestack.h>
class Stat
{
 public:
  QString filename;
  int data[9];
  QValueStack<QPoint> point;
  QValueStack<QRect> rect;
  Stat( QString newfilename )
    {
		 filename = newfilename; 
      int i;
      for(i = 0; i < 9; i ++)
	data[i] = 0;
    }
  void removeDups();
};  

class StatManager : public QWidget
{
  Q_OBJECT
    QDict<Stat> stats; //map of all stats
  QStringList files;  //list of all filenames
  QStringList filesViewed;
  QValueList<QString>::iterator it; //current position in the list
  Stat* current; //current stat
  //QDir imageDirectory; // directory with the miages

public :
  StatManager(QWidget* parent, const char* name);
public slots:  
  void next();
  void forward();
  void back();
  void openFiles(QStringList a);
  void openDir(QString);
  void openImages( QStringList filesToOpen );
  void openImageList( QString filename );
  void setdata(int member, int value )  			 { if( current != NULL ) current->data[member] = value; 	}
  void setrect( QValueStack<QRect> rect )            { if( current != NULL ) current->rect = rect;	}
  void setpoint( QValueStack<QPoint> point )            { if( current != NULL ) current->point = point;	}
  void savestats(Stat * ptr = NULL); 
  void openstats();
  void clear();
  void clearAll();
  void saveAll();
  void replay();
  void getMaxWindows();
  void popRect();
  void popPoint();

  void setage                       ( int a ) { if( current != NULL )  current->data[0] = a; }
  void setexpression                ( int a ) { if( current != NULL )  current->data[1] = a; }
  void setgender                    ( int a ) { if( current != NULL )  current->data[2] = a; }
  void setglasses                   ( int a ) { if( current != NULL )  current->data[3] = a; }
  void setangle                     ( int a ) { if( current != NULL )  current->data[4] = a; }
  void setrace                      ( int a ) { if( current != NULL )  current->data[5] = a; }
  void setbrightness                ( int a ) { if( current != NULL )  current->data[6] = a; }
  void setcomplexity                ( int a ) { if( current != NULL )  current->data[7] = a; }
  void settype                      ( int a ) { if( current != NULL )  current->data[8] = a; }
signals:
  void filenameChanged( QString );
  void directoryChanged( QString );
  void openFrom( QString, QString, bool );
  void dataChanged(int, int);
  void rectChanged( QValueStack<QRect> );
  void pointChanged( QValueStack<QPoint> );

  void openReplays();
  void setMaxWindows(int);
private:
 
	QStringList datnames[10]; //list of all filenames to save into
	QString		rectdatname;
	QString		pointdatname;
  
  void loadit();
  void saveto( QString, Stat * ptr = NULL);
  bool openf(FILE *& fh, const char * filename);
  bool openf(FILE *& fh, QString filename) { return openf( fh, filename.latin1() ); }
};
#endif
