#ifndef UBERWINDOW_H
#define UBERWINDOW_H
#include <qwidget.h>
#include <qlabel.h>
#include <qaction.h>
#include <qstringlist.h>
#include <qbuttongroup.h>
#include <qmainwindow.h>
class StatManager;
class FacesWidget;
class VehiclesWidget;
//label is a quick hack on qlabel, so that i can link directly into it
class Label : public QLabel
{
	Q_OBJECT
	public:
		Label( QWidget * parent, const char * name ) : QLabel( parent, name ) { }
	public slots:
		void setText( QString a ) { QLabel::setText( a ); }
};

class Window : public QMainWindow
{
  Q_OBJECT
 public:
  Window( QWidget* parent , const char* name , int , char **, QApplication* );
  protected slots:
  void open();
  void openListOfImages();
  void openDir();
 signals:
  void next();
  void openFrom(QStringList);
  void openImageList(QString);
  void openingDir(QString);
 protected slots:  
  void none();
  void faces(); /** displays the faces widget **/
  void vehicles(); /** displays the vehicles widget **/
  //cant connect straight to setButton so need these functions to be a go between
  void setData( int a, int b );
  void setAge(int a); 
  void setExpression(int a);
  void setGender(int a); 
  void setGlasses(int a);
  void setAngle(int a);
  void setRace(int a);
  void setBrightness(int a);
  void setComplexity(int a);
  void setType(int a);
  void aboutToQuit();
 public:
  Label* currentFile;
  Label* currentDirectory;
  StatManager* statManager;
  FacesWidget* facesWidget;
  VehiclesWidget* vehiclesWidget;
};
#endif
